//
//  GHMenulet.m
//  GameHub
//
//  Based on code from Minecraft Manager.
//  Created by evilGoldfish on 21/03/11.
//  Licensed under the Creative Commons.
//

#import "GHMenulet.h"
#import "MAAttachedWindow.h"
#import "GHMenuletIconView.h"


@implementation Menulet
-(void)dealloc
{
    [[NSStatusBar systemStatusBar] removeStatusItem:statusItem];
    [super dealloc];
}
- (void)awakeFromNib
{
    float width = 26.0;
    float height = [[NSStatusBar systemStatusBar] thickness];
    NSRect viewFrame = NSMakeRect(0, 0, width, height);
    statusItem = [[[NSStatusBar systemStatusBar] statusItemWithLength:width] retain];
    [statusItem setView:[[[MenuletIconView alloc] initWithFrame:viewFrame controller:self] autorelease]];
}

- (void)toggleAttachedWindowAtPoint:(NSPoint)pt
{
    // Attach/detach window.
    if (!attachedWindow) {
        attachPt = pt;
        attachedWindow = [[MAAttachedWindow alloc] initWithView:mainView 
                                                attachedToPoint:pt 
                                                       inWindow:nil 
                                                         onSide:MAPositionBottom 
                                                     atDistance:5.0];
        [attachedWindow setBackgroundColor:[NSColor colorWithCalibratedWhite:1.0 alpha:0.95]];
        [attachedWindow fadeInAndMakeKeyAndOrderFront:YES];
        [attachedWindow setLevel:NSFloatingWindowLevel];
        
    } else {
        [attachedWindow fadeOutAndOrderOut:YES];
        [attachedWindow release];
        attachedWindow = nil;
    }    
}

-(IBAction)testResize:(id)sender {
    NSRect newPopoverFrame = attachedWindow.frame;
    NSRect newPopoverContentViewFrame = mainView.frame;
    
    newPopoverFrame.size.height += 100;
    newPopoverContentViewFrame.size.height += 100;
    newPopoverFrame.size.width += 100;
    newPopoverContentViewFrame.size.width += 100;
    
    [NSAnimationContext beginGrouping];
    [[mainView animator] setFrame: newPopoverContentViewFrame];
    [[attachedWindow animator] setFrame: newPopoverFrame display: YES animate: YES];
    [NSAnimationContext endGrouping];
    //[attachedWindow setFrame:newFrame display:YES animate:YES];
}

@end