//
//  GHMenuletIconView.m
//  GameHub
//
//  Based on code from Minecraft Manager.
//  Created by Evan Petousis on 30/11/2012.
//  Copyright 2012 1-Bit Software. All rights reserved.
//

#import "GHMenuletIconView.h"
#import "GHMenulet.h"


@implementation MenuletIconView


- (id)initWithFrame:(NSRect)frame controller:(Menulet *)ctrlr
{
    if (self = [super initWithFrame:frame]) {
        controller = ctrlr; // deliberately weak reference.
    }
    
    return self;
}


- (void)dealloc
{
    controller = nil;
    [super dealloc];
}


- (void)drawRect:(NSRect)rect {
    // Draw background if appropriate.
    if (clicked) {
        [[NSColor selectedMenuItemColor] set];
        NSRectFill(rect);
    }
    
    NSBundle *bundle = [NSBundle bundleForClass:[self class]];
	NSString *path = [bundle pathForResource:@"MenuIcon" ofType:@"png"];
	NSImage *menuIcon= [[NSImage alloc] initWithContentsOfFile:path];
    
    NSPoint pt = NSMakePoint((NSWidth([self bounds]) - menuIcon.size.width) / 2, ((NSHeight([self bounds]) - menuIcon.size.width) / 2) + 1);
    [menuIcon drawAtPoint:pt fromRect:NSZeroRect operation:NSCompositeSourceOver fraction:1];
}

/*-(void)rightMouseDown:(NSEvent *)theEvent {
    NSLog(@"Right mouse down on menu icon.");
    NSRect frame = [[self window] frame];
    NSPoint pt = NSMakePoint(NSMidX(frame), NSMinY(frame));
    [controller toggleQuitAttachedWindowAtPoint:pt];
    clicked = true;
    [self setNeedsDisplay:YES];
}*/

- (void)mouseDown:(NSEvent *)event
{
    NSLog(@"Left mouse down on menu icon.");
    NSRect frame = [[self window] frame];
    NSPoint pt = NSMakePoint(NSMidX(frame), NSMinY(frame));
    [controller toggleAttachedWindowAtPoint:pt];
    clicked = !clicked;
    [self setNeedsDisplay:YES];
}

@end
