//
//  GHOverlayWindow.m
//  GameHub
//
//  Created by Evan Petousis on 29/11/12.
//  Copyright (c) 2012 1-Bit Software. All rights reserved.
//

#import "GHOverlayWindow.h"
#define _contextDuration 0.25 // Defines the length of animations - default is 0.25

@implementation GHOverlayWindow

-(IBAction)makeKeyAndOrderFrontWithFadeIn:(id)sender {
    [[NSAnimationContext currentContext] setDuration:_contextDuration];
    NSUserDefaults *userDefaults = [[NSUserDefaults alloc] init];
    if (userDefaults) {
        if(![userDefaults objectForKey:@"bgColor"]) {
            [self setBackgroundColor:[NSColor orangeColor]];
            [[NSColorPanel sharedColorPanel] setColor:[NSColor orangeColor]];
        }else{
            [self setBackgroundColor:[NSUnarchiver unarchiveObjectWithData:[userDefaults objectForKey:@"bgColor"]]];
            [[NSColorPanel sharedColorPanel] setColor:[NSUnarchiver unarchiveObjectWithData:[userDefaults objectForKey:@"bgColor"]]];
        }
    }
    [self setAlphaValue:0];
    [self makeKeyAndOrderFront:sender];
    [[self animator] setAlphaValue:1];
}

-(IBAction)closeWithFadeOut:(id)sender {
    [[self animator] setAlphaValue:0];
    colorPanel = nil;
    [self performSelector:@selector(close) withObject:nil afterDelay:_contextDuration];
    [NSApp performSelector:@selector(hide:) withObject:self afterDelay:_contextDuration];
}

-(IBAction)pickColorForBackground:(id)sender {
    [[NSColorPanel sharedColorPanel] setLevel:25];
    [[NSColorPanel sharedColorPanel] setRestorable:NO];
    [[NSColorPanel sharedColorPanel] setDelegate:self];
    [[NSColorPanel sharedColorPanel] makeKeyAndOrderFront:self];
}

- (void)keyDown:(NSEvent *)event {
    NSUInteger key = 48;
    NSUInteger modifier = NSShiftKeyMask;
    if ([event keyCode] == key && [NSEvent modifierFlags] == modifier) {
        [self closeWithFadeOut:self];
    }
}

-(void)changeColor:(id)sender {
    NSColorPanel *tempPanel = sender;
    [self setBackgroundColor:tempPanel.color];
    NSUserDefaults *userDefaults = [[NSUserDefaults alloc] init];
    if (userDefaults) {
        NSData *colorData=[NSArchiver archivedDataWithRootObject:tempPanel.color];
        [userDefaults setObject:colorData forKey:@"bgColor"];
        [userDefaults synchronize];
    }
}

-(BOOL)canBecomeKeyWindow {
    return YES;
}

-(BOOL)acceptsFirstResponder {
    return YES;
}

-(IBAction)sendTweet:(id)sender {
    
}

@end
